// ArmApiCall.h

#ifndef ARMAPICALL_H
#define ARMAPICALL_H

#include <PalmOS.h>

#ifdef __cplusplus
extern "C" {
#endif

//	SystemTable 0x18 AlmGetAlarm
//	SystemTable 0x1C AlmGetAlarmV40

//	SystemTable 0x24 AlmSetAlarm
#ifdef AlmSetAlarm
#undef AlmSetAlarm
#endif
#define AlmSetAlarm AlmSetAlarmV50
Err AlmSetAlarmV50(LocalID dbID, UInt32 ref, UInt32 alarmSeconds, Boolean quiet);
//	SystemTable 0x28 AlmSetAlarmV40
Err AlmSetAlarmV40(UInt16 cardNo, LocalID dbID, UInt32 ref, UInt32 alarmSeconds, Boolean quiet);

//	UITable 0x1C AttnGetAttention
//	SystemTable 0x30 AttnGetAttentionV40

//	UITable 0x54 AttnUpdate
//	SystemTable 0x34 AttnUpdateV40

//	UITable 0x18 AttnForgetIt
//	SystemTable 0x38 AttnForgetItV40

//	UITable 0x20 AttnGetCounts
//	SystemTable 0x3C AttnGetCountsV40

//	UITable 0x28 AttnIterate
//	SystemTable 0x40 AttnIterateV40

//	SystemTable 0x120 DmCreateDatabase
//	SystemTable 0x128 DmCreateDatabaseV40

//	SystemTable 0x12C DmDatabaseInfo
#ifdef DmDatabaseInfo
#undef DmDatabaseInfo
#endif
#define DmDatabaseInfo DmDatabaseInfoV50
Err DmDatabaseInfoV50(LocalID dbID, Char *nameP, UInt16 *attributesP, UInt16 *versionP, UInt32 *crDateP, UInt32 *modDateP, UInt32 *bckUpDateP, UInt32 *modNumP, LocalID *appInfoIDP, LocalID *sortInfoIDP, UInt32 *typeP, UInt32 *creatorP);
//	SystemTable 0x130 DmDatabaseInfoV40
Err DmDatabaseInfoV40(UInt16 cardNo, LocalID dbID, Char *nameP, UInt16 *attributesP, UInt16 *versionP, UInt32 *crDateP, UInt32 *modDateP, UInt32 *bckUpDateP, UInt32 *modNumP, LocalID *appInfoIDP, LocalID *sortInfoIDP, UInt32 *typeP, UInt32 *creatorP);

//	SystemTable 0x134 DmDatabaseProtect
#ifdef DmDatabaseProtect
#undef DmDatabaseProtect
#endif
#define DmDatabaseProtect DmDatabaseProtectV50
Err DmDatabaseProtectV50(LocalID dbID, Boolean protect);
//	SystemTable 0x138 DmDatabaseProtectV40
Err DmDatabaseProtectV40(UInt16 cardNo, LocalID dbID, Boolean protect);

//	SystemTable 0x13C DmDatabaseSize
//	SystemTable 0x140 DmDatabaseSizeV40

//	SystemTable 0x148 DmDeleteDatabase
//	SystemTable 0x14C DmDeleteDatabaseV40

//	SystemTable 0x15C DmFindDatabase
//	SystemTable 0x160 DmFindDatabaseV40

//	SystemTable 0x168 DmFindDatabaseWithTypeCreator
//	SystemTable 0x164 DmFindDatabaseWithTypeCreatorV40

//	SystemTable 0x188 DmGetDatabase
//	SystemTable 0x190 DmGetDatabaseV40

//	SystemTable 0x198 DmGetNextDatabaseByTypeCreator
#ifdef DmGetNextDatabaseByTypeCreator
#undef DmGetNextDatabaseByTypeCreator
#endif
#define DmGetNextDatabaseByTypeCreator DmGetNextDatabaseByTypeCreatorV50
Err DmGetNextDatabaseByTypeCreatorV50(Boolean newSearch, DmSearchStatePtr stateInfoP, UInt32 type, UInt32 creator, Boolean onlyLatestVers, LocalID *dbIDP);
//	SystemTable 0x19C DmGetNextDatabaseByTypeCreatorV40
Err DmGetNextDatabaseByTypeCreatorV40(Boolean newSearch, DmSearchStatePtr stateInfoP, UInt32 type, UInt32 creator, Boolean onlyLatestVers, UInt16 *cardNoP, LocalID *dbIDP);

//	SystemTable 0x1D4 DmNumDatabases
//	SystemTable 0x1D8 DmNumDatabasesV40

//	SystemTable 0x1F0 DmOpenDatabaseInfo
//	SystemTable 0x1F4 DmOpenDatabaseInfoV40

//	SystemTable 0x1F8 DmOpenDatabaseV40
//	SystemTable 0x1F8 DmOpenDatabaseV40

//	SystemTable 0x1FC DmOpenDBNoOverlay
//	SystemTable 0x200 DmOpenDBNoOverlayV40

//	SystemTable 0x250 DmSetDatabaseInfo
//	SystemTable 0x254 DmSetDatabaseInfoV40

//	SystemTable 0x2FC ExgDBRead
//	SystemTable 0x300 ExgDBReadV40

//	SystemTable 0x304 ExgDBWrite
//	SystemTable 0x308 ExgDBWriteV40

//	SystemTable 0x39C FileDelete
//	SystemTable 0x3A0 FileDeleteV40

//	SystemTable 0x3A4 FileOpen
//	SystemTable 0x3A8 FileOpenV40

//	UITable 0x10C FindSaveMatch
//	SystemTable 0x3C0 FindSaveMatchV40

//	UITable 0x390 LstSetDrawFunction
//	SystemTable 0x4A8 LstSetDrawFunctionV40

//	SystemTable 0x4B4 MemCardInfoV40

//	SystemTable 0x4B8 MemChunkFree
#ifdef MemPtrFree
#undef MemPtrFree
#endif
#define MemPtrFree MemChunkFree

//	SystemTable 0x4D0 MemHandleCardNoV40

//	SystemTable 0x504 MemHandleToLocalIDV40

//	SystemTable 0x524 MemHeapID
//	SystemTable 0x528 MemHeapIDV40

//	SystemTable 0x548 MemLocalIDKindV40

//	SystemTable 0x54C MemLocalIDToGlobalV40

//	SystemTable 0x550 MemLocalIDToLockedPtrV40

//	SystemTable 0x554 MemLocalIDToPtrV40

//	SystemTable 0x55C MemNumCardsV40

//	SystemTable 0x560 MemNumHeaps
//	SystemTable 0x564 MemNumHeapsV40

//	SystemTable 0x568 MemNumRAMHeaps
//	SystemTable 0x56C MemNumRAMHeapsV40

//	SystemTable 0x574 MemPtrCardNoV40

//	SystemTable 0x5A0 MemPtrToLocalIDV40

//	SystemTable 0x5B8 MemStoreInfo
//	SystemTable 0x5BC MemStoreInfoV40

//	SystemTable 0x5C4 MemStoreSetInfo
//	SystemTable 0x5C8 MemStoreSetInfoV40

//	SystemTable 0x7C8 SysAppLaunch
//	SystemTable 0x7CC SysAppLaunchV40

//	SystemTable 0x7D8 SysBatteryInfo
//	SystemTable 0x7E0 SysBatteryInfoV40

//	SystemTable 0x800 SysCurAppDatabase
#ifdef SysCurAppDatabase
#undef SysCurAppDatabase
#endif
#define SysCurAppDatabase SysCurAppDatabaseV50
Err SysCurAppDatabaseV50(LocalID *dbIDP);
//	SystemTable 0x804 SysCurAppDatabaseV40
Err SysCurAppDatabaseV40(UInt16 *cardNoP, LocalID *dbIDP);

//	SystemTable 0x824 SysEventGet
void SysEventGet(SysEventType *event, Int32 timeout);

//	SystemTable 0x840 SysGetROMToken
//	SystemTable 0x844 SysGetROMTokenV40

//	SystemTable 0x868 SysLibFindV40

//	SystemTable 0x86C SysLibInstallV40

//	SystemTable 0x860 SysLibLoad
//	SystemTable 0x870 SysLibLoadV40

//	SystemTable 0x864 SysLibRemove
//	SystemTable 0x874 SysLibRemoveV40

//	SystemTable 0x89C SysNotifyRegister
#ifdef SysNotifyRegister
#undef SysNotifyRegister
#endif
#define SysNotifyRegister SysNotifyRegisterV50
Err SysNotifyRegisterV50(LocalID dbID, UInt32 notifyType, SysNotifyProcPtr callbackP, Int8 priority, void *userDataP);
//	SystemTable 0x8A0 SysNotifyRegisterV40
Err SysNotifyRegisterV40(UInt16 cardNo, LocalID dbID, UInt32 notifyType, SysNotifyProcPtr callbackP, Int8 priority, void *userDataP);

//	SystemTable 0x8A4 SysNotifyUnregister
#ifdef SysNotifyUnregister
#undef SysNotifyUnregister
#endif
#define SysNotifyUnregister SysNotifyUnregisterV50
Err SysNotifyUnregisterV50(LocalID dbID, UInt32 notifyType, Int8 priority);
//	SystemTable 0x8A8 SysNotifyUnregisterV40
Err SysNotifyUnregisterV40(UInt16 cardNo, LocalID dbID, UInt32 notifyType, Int8 priority);

//	SystemTable 0x8B0 SysPatchEntry
Boolean SysPatchEntry(UInt16 tbl, UInt16 offset, void* newAddr, void** prevAddr);

//	SystemTable 0x8D8 SysSleep
//	SystemTable 0x8DC SysSleepV40

//	SystemTable 0x8E8 SysTaskDelay
//	SystemTable 0x8EC SysTaskDelayV40

//	SystemTable 0x8F8 SysUIAppSwitch
#ifdef SysUIAppSwitch
#undef SysUIAppSwitch
#endif
#define SysUIAppSwitch SysUIAppSwitchV50
Err SysUIAppSwitchV50(LocalID dbID, UInt16 cmd, MemPtr cmdPBP);
//	SystemTable 0x8FC SysUIAppSwitchV40
Err SysUIAppSwitchV40(UInt16 cardNo, LocalID dbID, UInt16 cmd, MemPtr cmdPBP);

//	SystemTable 0xA44 VFSExportDatabaseToFile
//	SystemTable 0xA48 VFSExportDatabaseToFileV40

//	SystemTable 0xA4C VFSExportDatabaseToFileCustom
//	SystemTable 0xA50 VFSExportDatabaseToFileCustomV40

//	SystemTable 0xAA8 VFSImportDatabaseFromFile
//	SystemTable 0xAAC VFSImportDatabaseFromFileV40

//	SystemTable 0xAB0 VFSImportDatabaseFromFileCustom
//	SystemTable 0xAB4 VFSImportDatabaseFromFileCustomV40
//	UITable 0x564 UIGetGlobalsPtr
MemPtr UIGetGlobalsPtr(void);

#ifdef __cplusplus 
}
#endif

#endif