// MenuAddItem.cpp

#include <PalmOS.h>
#include "ArmApiCall.h"

#define RESID	0x03e9
#define CRID	'To-f'

#define myApiMenuAddItem __myApiEntry__ 

Err myApiMenuAddItem(UInt16 positionId, UInt16 id, Char cmd, const Char *textP);
typedef Err (*osApi)(UInt16 positionId, UInt16 id, Char cmd, const Char *textP);

void prepTof(UInt8* from, UInt8* to);

Err myApiMenuAddItem(UInt16 positionId, UInt16 id, Char cmd, const Char *textP)
{
	UInt8* from = (UInt8*)textP;
	UInt8* to = (UInt8*)((UInt32)from + StrLen(textP));

	prepTof(from, to);

	osApi osApiMenuAddItem;
	FtrGet(CRID, RESID, (UInt32*)&osApiMenuAddItem);

	return osApiMenuAddItem(positionId, id, cmd, textP);
}

#pragma thumb on
void prepTof(UInt8* from, UInt8* to)
{
	#include <CharLatin.h>
	for(UInt8* i = from; i < to; i++)
	{	if(i[0] == chrHorizontalEllipsis)
		{	if(i[1] == chrNull)
				i[0] = chrEllipsis;
		}
		else if(i[0] == chrFullStop)
		{	if((i[1] == chrFullStop) && (i[2] == chrFullStop) && (i[3] == chrNull))
			{	i[0] = chrEllipsis;	i[1] = chrNull; i += 3;
			}
		}
	}
}
#pragma thumb reset

// Don't care below -----------------------
// Simple Startp code ---------------------
// Always compile as ARM instruction set --

extern "C" void __ARMlet_Startup__(void);

#pragma thumb off
asm void __ARMlet_Startup__(void)
{
	b __myApiEntry__
}
#pragma thumb reset