// NewStack.c

#include "NewStack.h"

#ifndef NewStackSize
#define NewStackSize	#1024*4	// default new-stack size = 4KByte
#endif

#ifndef CopySize
#define CopySize		#14*4	// default copy arg5 to arg9
#endif
								// Num arg.  CopySize
								// 0-4        #9 *4
								// 5          #10*4
								// 6          #11*4
								// 7          #12*4
								// 8          #13*4
								// 9          #14*4
								// 10         #15*4
								// ...        ...

#pragma thumb off

asm void __NewStack__(void)
{
	stmfd sp!,{r0-r6,lr}		// store r0 to r6 and lr
	mov r0, NewStackSize
	bl MemPtrNew				// allocate new-stack
	mov r4, r0					// store newStackBase to r4
	add r5, r0, NewStackSize	// now r5 point to new-sp
	stmfd r5!,{r4, sp}			// store newStackBase, org-sp to newStack
	sub r5, r5, CopySize		// shift new-sp
	mov r0, r5					// copy to new-sp
	mov r1, sp					// copy from org-sp
	mov r2, CopySize			// copy-size
	bl MemMove					// copy data to new-sp from org-sp
	mov sp, r5					// replace sp to new-sp
	ldmfd sp!,{r0-r6,lr}		// restore bloken register r0 to r6 and lr
	add sp, sp, #4 				// no-need lr. it's stored in org-sp
	bx lr
}

asm void __RestoreStack__(void)
{
	stmfd sp!,{r0,lr}	// store r0 and lr
	// Point-D
	ldr r0, [sp,CopySize - 28]	// pop new-stack base address
	bl MemPtrFree		// free up
	ldmfd sp!,{r0,lr}	// restore r0 and lr
	// Point-E
	ldr sp, [sp,CopySize - 32]	// pop org-sp and restore
	add sp, sp, #32		// prepair sp must point to
	bx lr
}

#pragma thumb reset

// function call --------------------
// ReturnValue func(arg1, arg2, arg3, arg4, arg5, arg6,    arg7,...)
// ^r0              ^r0   ^r1   ^r2   ^r3   ^[sp] ^[sp,#4] ^[sp,#8]

//	asm void __ARMlet_Startup__(void)
//	{
//		// Point-A
//		stmfd sp!,{lr}
//		bl __NewStack__
//		// Point-B
//		bl __myApiEntry__
//		// Point-C
//		bl __RestoreStack__
//		// Point-F
//		ldmfd sp!,{lr}
//		bx lr
//	}

// @Point-A -------------------------
// r0 = arg1
// r1 = arg2
// r2 = arg3
// r3 = arg4
// lr = org-return-address
// | arg5                   | <-sp
// | arg6                   |
// | arg7                   |
// | ...                    |

// @Point-B -------------------------
// r0 = arg1
// r1 = arg2
// r2 = arg3
// r3 = arg4
// lr 
// | arg5                   | <-new-sp
// | arg6                   |
// | arg7                   |
// | ...                    |
// | ...                    |
// | new-stack base address |
// | org-sp                 |

// | r0                     | <-old-sp
// | r1                     |
// | r2                     |
// | r3                     |
// | r4                     |
// | r5                     |
// | r6                     |
// | lr                     |
// | org-return-address     |
// | arg5                   |
// | arg6                   |
// | arg7                   |
// | ...                    |

// @Point-C -------------------------
// r0 = return-value
// lr
// | arg5                   | <-new-sp
// | arg6                   |
// | arg7                   |
// | ...                    |
// | ...                    |
// | new-stack base address |
// | org-sp                 |

// @Point-D -------------------------
// r0
// lr
// | r0 = return-value      | <-new-sp
// | lr                     | +4
// | arg5                   | +8
// | arg6                   | +12
// | arg7                   | +16
// | ...                    | +20
// | ...                    | +24
// | new-stack base address | +28
// | org-sp                 | +32

// @Point-E -------------------------
// r0 = return-value
// lr
// | arg5                   | <-new-sp
// | arg6                   | +4
// | arg7                   | +8
// | ...                    | +12
// | ...                    | +16
// | new-stack base address | +20
// | org-sp                 | +24

// | r0                     | <-old-sp
// | r1                     | +4
// | r2                     | +8
// | r3                     | +12
// | r4                     | +16
// | r5                     | +20
// | r6                     | +24
// | lr                     | +28
// | org-return-address     | +32 <-sp must point here
// | arg5                   |
// | arg6                   |
// | arg7                   |
// | ...                    |

// @Point-F -------------------------
// r0 = return-value
// lr
// | org-return-address     | <-sp
// | arg5                   |
// | arg6                   |
// | arg7                   |
// | ...                    |

