// ResLoadMenu.cpp

#define ALLOW_ACCESS_TO_INTERNALS_OF_MENUS_OS5

#include <PalmOS.h>
#include "MenuOS5.h"
#include "ArmApiCall.h"
#include "ARMRes.h"

#define RESID	0x03e8
#define CRID	'To-f'

#define myApiResLoadMenu __myApiEntry__ 

void* myApiResLoadMenu(UInt16 rscID);
typedef void* (*osApi)(UInt16 rscID);

UInt32 prepTof(UInt8* from, UInt8* to);
 
void* myApiResLoadMenu(UInt16 rscID)
{
	osApi osApiResLoadMenu;
	FtrGet(CRID, RESID, (UInt32*)&osApiResLoadMenu);

	MenuBarPtrOS5 menuP = (MenuBarPtrOS5)osApiResLoadMenu(rscID);

	UInt8* from = (UInt8*)menuP->menus[0].title;
	UInt8* to = (UInt8*)((UInt32)menuP + MemPtrSize(menuP));

	UInt32 count = prepTof(from, to);

	if(count)
	{	DmOpenRef dbRef = DmOpenDatabaseByTypeCreator('HACK', CRID, dmModeReadOnly);
		if(dbRef)
		{	Char t[10];
			StrIToA(t, count);
			FrmCustomAlert(FoundMessage, t, "", "");
			DmCloseDatabase(dbRef);
		}
	}

	return menuP;
}

#pragma thumb on
UInt32 prepTof(UInt8* from, UInt8* to)
{
	UInt32 which = 0;
	FtrGet(CRID, 0, &which);

	UInt8 replaceTo;
	switch(which)
	{	case 0:
			replaceTo = chrEllipsis;
			break;
		case 1:
			replaceTo = '_';
			break;
		case 2:
			replaceTo = '-';
	}

	UInt32 count = 0;
	#include <CharLatin.h>
	for(UInt8* i = from; i < to; i++)
	{	if(i[0] == chrHorizontalEllipsis)
		{	if(i[1] == chrNull)
			{	i[0] = replaceTo;
				count++;
			}
		}
		else if(i[0] == chrFullStop)
		{	if((i[1] == chrFullStop) && (i[2] == chrFullStop) && (i[3] == chrNull))
			{	i[0] = replaceTo;	i[1] = chrNull; i += 3;
				count++;
			}
		}
	}
	return count;
}
#pragma thumb reset

// Don't care below -----------------------
// Simple Startp code ---------------------
// Allocate new-stack and call myApi ------
// Always compile as ARM instruction set --

extern "C" void __ARMlet_Startup__(void);

#include "NewStack.h"

#pragma thumb off

asm void __ARMlet_Startup__(void)
{
	stmfd sp!,{lr}
	bl __NewStack__		// allocate new-stack
	bl __myApiEntry__	// call myApi with new-stack
	bl __RestoreStack__	// restore stack
	ldmfd sp!,{lr}
	bx lr
}

#pragma thumb reset
